package net.sf.itcb.common.portlet.vaadin.page;

import net.sf.itcb.common.portlet.vaadin.PageMappingProcessor;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.vaadin.ui.VerticalLayout;

/**
 * Each page has to extend this class
 * 
 * @author Pierre Le Roux
 *
 */
public abstract class AbstractItcbPortletPage extends VerticalLayout {

	private static final long serialVersionUID = 1L;

	private PageMappingProcessor pageMappingProcessor;
	
	protected final Logger log = LoggerFactory.getLogger(getClass());
		
	public void setPageMappingProcessor(PageMappingProcessor pageMappingProcessor) {
		this.pageMappingProcessor = pageMappingProcessor;
	}
	
	public PageMappingProcessor getPageMappingProcessor() {
		return pageMappingProcessor;
	}
	
	public void initPage() {
		log.debug("Initializing {}", getClass());
		removeAllComponents();
		setMargin(false);
		setSpacing(false);
		try {
			defineContentDelegate();
		}
		catch(Exception e) {
			pageMappingProcessor.handleException(e);
		}
	}
	
	protected abstract void defineContentDelegate() throws Exception;
	   	
}

